Index: stable/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/history.cshtml
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/history.cshtml	(revision 12428)
+++ stable/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/history.cshtml	(revision 12563)
@@ -12,5 +12,5 @@
 <div id="history-header">
     <form class="form-inline">
-        <div class="form-group">
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
             <label for="fromDate">From:&nbsp;</label>
             <div class="input-group">
@@ -21,6 +21,6 @@
             </div>
         </div>
-        <div class="form-group">
-            <label for="fromDate">&nbsp;&nbsp;To:&nbsp;</label>
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+            <label for="fromDate">To:&nbsp;</label>
             <div class="input-group">
                 <input id="fromDate" type="text" class="form-control" datepicker-popup="dd.MM.yyyy" ng-model="toDate" is-open="toIsOpen" datepicker-options="dateOptions" ng-required="true" close-text="Close" />
@@ -29,4 +29,9 @@
                 </span>
             </div>
+        </div>
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+            <button type="button" class="btn btn-default" ng-click="updateCharts()">
+                Apply
+            </button>
         </div>
     </form>
Index: stable/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/historyCtrl.js
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/historyCtrl.js	(revision 12428)
+++ stable/HeuristicLab.Services.WebApp.Status/3.3/WebApp/history/historyCtrl.js	(revision 12563)
@@ -4,5 +4,4 @@
         ['$scope', '$interval', 'app.status.data.service',
         function ($scope, $interval, dataService) {
-
             $scope.chartOptions = {
                 grid: {
@@ -15,17 +14,9 @@
                 yaxis: {
                     min: 0,
-                    max: 100,
-                    zoomRange: false,
-                    panRange: false
+                    max: 100
                 },
                 xaxis: {
                     mode: "time",
                     twelveHourClock: false
-                },
-                zoom: {
-                    interactive: true
-                },
-                pan: {
-                    interactive: true
                 }
             };
@@ -43,19 +34,10 @@
                     }
                 },
-                yaxis: {
-                    zoomRange: false,
-                    panRange: false
-                },
                 xaxis: {
                     mode: "time",
                     twelveHourClock: false
-                },
-                zoom: {
-                    interactive: true
-                },
-                pan: {
-                    interactive: true
                 }
             };
+
 
             $scope.fromDate = new Date();
@@ -88,6 +70,6 @@
             $scope.memorySeries = [[]];
 
-            var updateCharts = function () {
-                dataService.getStatusHistory({start: ConvertFromDate($scope.fromDate), end: ConvertToDate($scope.toDate)}, function (status) {
+            $scope.updateCharts = function () {
+                dataService.getStatusHistory({ start: ConvertFromDate($scope.fromDate), end: ConvertToDate($scope.toDate) }, function (status) {
                     var noOfStatus = status.length;
                     var cpuSeries = [];
@@ -96,12 +78,10 @@
                     for (var i = 0; i < noOfStatus; ++i) {
                         var curStatus = status[i];
-                        var cpuData = Math.round(curStatus.CpuUtilizationStatus.UsedCpuUtilization);
-                        var usedCores = curStatus.CoreStatus.TotalCores - curStatus.CoreStatus.FreeCores;
-                        var usedMemory = curStatus.MemoryStatus.TotalMemory - curStatus.MemoryStatus.FreeMemory;
+                        var cpuData = Math.round(curStatus.CpuUtilizationStatus.ActiveCpuUtilization);
                         cpuSeries.push([curStatus.Timestamp, cpuData]);
-                        coreSeries[0].push([curStatus.Timestamp, curStatus.CoreStatus.TotalCores]);
-                        coreSeries[1].push([curStatus.Timestamp, usedCores]);
-                        memorySeries[0].push([curStatus.Timestamp, curStatus.MemoryStatus.TotalMemory]);
-                        memorySeries[1].push([curStatus.Timestamp, usedMemory]);
+                        coreSeries[0].push([curStatus.Timestamp, curStatus.CoreStatus.ActiveCores]);
+                        coreSeries[1].push([curStatus.Timestamp, curStatus.CoreStatus.CalculatingCores]);
+                        memorySeries[0].push([curStatus.Timestamp, Math.round(curStatus.MemoryStatus.ActiveMemory / 1024)]);
+                        memorySeries[1].push([curStatus.Timestamp, Math.round(curStatus.MemoryStatus.UsedMemory / 1024)]);
                     }
                     $scope.cpuSeries = [{ data: cpuSeries, label: "&nbsp;CPU Utilization", color: "#f7921d" }];
@@ -117,11 +97,5 @@
                 });
             };
-
-            $scope.$watch('fromDate', function (newValue, oldValue) {
-                updateCharts();
-            });
-            $scope.$watch('toDate', function (newValue, oldValue) {
-                updateCharts();
-            });
+            $scope.updateCharts();
         }]
     );
Index: stable/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/status.cshtml
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/status.cshtml	(revision 12428)
+++ stable/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/status.cshtml	(revision 12563)
@@ -11,123 +11,272 @@
 
 <div class="default-view-container">
-    <div class="row">
-        <div class="col-lg-3 col-md-6">
-            <div class="panel panel-default">
-                <div class="panel-heading">
-                    <h3 class="panel-title">Cores</h3>
-                </div>
+<div class="row">
+    <div class="col-lg-3 col-md-6">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">Cores</h3>
+            </div>
+            <div class="panel-body">
+                <div class="text-center">
+                    <knob knob-data="core.knobData" knob-options="knobOptions"></knob>
+                </div>
+                <table class="table table-no-border table-condensed table-auto-width table-content">
+                    <tr data-toggle="tooltip" data-placement="bottom" title="All online slaves">
+                        <td class="text-left">
+                            Total:
+                        </td>
+                        <td class="text-right">{{status.CoreStatus.TotalCores | number}}</td>
+                    </tr>
+                    <tr data-toggle="tooltip" data-placement="bottom" title="All calculating and idle slaves that are allowed to calculate">
+                        <td class="text-left">Active:</td>
+                        <td class="text-right">{{status.CoreStatus.ActiveCores | number}}</td>
+                    </tr>
+                    <tr data-toggle="tooltip" data-placement="bottom" title="All calculating slaves that are allowed to calculate">
+                        <td class="text-left">Calculating:</td>
+                        <td class="text-right">{{status.CoreStatus.CalculatingCores | number}}</td>
+                    </tr>
+                </table>
+            </div>
+        </div>
+    </div>
+
+    <div class="col-lg-3 col-md-6">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">CPU Utilization</h3>
+            </div>
+            <div class="panel-body">
+                <div class="text-center">
+                    <knob knob-data="cpu.knobData" knob-options="knobOptions"></knob>
+                </div>
+                <table class="table table-no-border table-condensed table-auto-width table-content">
+                    <tr data-toggle="tooltip" data-placement="bottom" title="All online slaves">
+                        <td class="text-left">Total:</td>
+                        <td class="text-right">{{status.CpuUtilizationStatus.TotalCpuUtilization | number: 2}} %</td>
+                    </tr>
+                    <tr data-toggle="tooltip" data-placement="bottom" title="All calculating and idle slaves that are allowed to calculate">
+                        <td class="text-left">Active:</td>
+                        <td class="text-right">{{status.CpuUtilizationStatus.ActiveCpuUtilization | number: 2}} %</td>
+                    </tr>
+                    <tr data-toggle="tooltip" data-placement="bottom" title="All calculating slaves that are allowed to calculate">
+                        <td class="text-left">Calculating:</td>
+                        <td class="text-right">{{status.CpuUtilizationStatus.CalculatingCpuUtilization | number: 2}} %</td>
+                    </tr>
+                </table>
+            </div>
+        </div>
+    </div>
+
+    <div class="col-lg-3 col-md-6">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">Memory</h3>
+            </div>
+            <div class="panel-body">
+                <div class="text-center">
+                    <knob knob-data="memory.knobData" knob-options="knobOptions"></knob>
+                </div>
+                <table class="table table-no-border table-condensed table-auto-width table-content">
+                    <tr data-toggle="tooltip" data-placement="bottom" title="All online slaves">
+                        <td class="text-left">Total:</td>
+                        <td class="text-right">{{status.MemoryStatus.TotalMemory | kbToGB}} GB</td>
+                    </tr>
+                    <tr data-toggle="tooltip" data-placement="bottom" title="All calculating and idle slaves that are allowed to calculate">
+                        <td class="text-left">Active:</td>
+                        <td class="text-right">{{status.MemoryStatus.ActiveMemory | kbToGB}} GB</td>
+                    </tr>
+                    <tr data-toggle="tooltip" data-placement="bottom" title="All calculating slaves that are allowed to calculate">
+                        <td class="text-left">Calculating:</td>
+                        <td class="text-right">{{status.MemoryStatus.UsedMemory | kbToGB}} GB</td>
+                    </tr>
+                </table>
+            </div>
+        </div>
+    </div>
+
+    <div class="col-lg-3 col-md-6">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">Tasks</h3>
+            </div>
+            <div class="panel-body">
+                <table class="table table-no-border table-condensed table-auto-width table-content">
+                    <tr>
+                        <td class="text-left">Total:</td>
+                        <td class="text-right">{{tasks.WaitingTasks + tasks.CalculatingTasks | number}}</td>
+                    </tr>
+                    <tr>
+                        <td class="text-left">Waiting:</td>
+                        <td class="text-right">{{tasks.WaitingTasks | number}}</td>
+                    </tr>
+                    <tr>
+                        <td class="text-left">Calculating:</td>
+                        <td class="text-right">{{tasks.CalculatingTasks | number}}</td>
+                    </tr>
+                </table>
+            </div>
+        </div>
+    </div>
+</div>
+
+<div class="row">
+    <div class="col-lg-12">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">CPU Utilization Chart</h3>
+            </div>
+            <div class="panel-body">
+                <flot dataset="cpu.series" options="chartOptions"></flot>
+            </div>
+        </div>
+    </div>
+</div>
+
+<div class="row">
+    <div class="col-lg-12">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">Core Chart</h3>
+            </div>
+            <div class="panel-body">
+                <flot dataset="core.series" options="fillChartOptions"></flot>
+            </div>
+        </div>
+    </div>
+</div>
+
+<div class="row">
+    <div class="col-lg-12">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">Memory Chart</h3>
+            </div>
+            <div class="panel-body">
+                <flot dataset="memory.series" options="fillChartOptions"></flot>
+            </div>
+        </div>
+    </div>
+</div>
+
+<div class="row">
+    <div class="col-lg-12">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">Tasks by User</h3>
+            </div>
+            <div class="panel-body">
+                <table class="table table-hover" ts-wrapper>
+                    <thead>
+                        <tr>
+                            <th ts-criteria="User.Name">Username</th>
+                            <th ts-criteria="CalculatingTasks|parseInt">Calculating Tasks</th>
+                            <th ts-criteria="WaitingTasks|parseInt">Waiting Tasks</th>
+                        </tr>
+                    </thead>
+                    <tbody>
+                        <tr ng-repeat="task in status.TasksStatus" ts-repeat>
+                            <td>{{task.User.Name}}</td>
+                            <td>{{task.CalculatingTasks | number}}</td>
+                            <td>{{task.WaitingTasks | number}}</td>
+                        </tr>
+                        <tr ng-hide="status.TasksStatus.length">
+                            <td colspan="3" class="text-center">
+                                There are no waiting or calculating tasks available!
+                            </td>
+                        </tr>
+                    </tbody>
+                </table>
+            </div>
+        </div>
+    </div>
+</div>
+
+<div class="row">
+    <div class="col-lg-12">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">
+                    <a data-toggle="collapse" data-target="#collapseActiveCalculatingSlaves"
+                       ng-href="#/status">
+                        Active Calculating Slaves
+                    </a>
+                </h3>
+            </div>
+            <div id="collapseActiveCalculatingSlaves"
+                 class="panel-collapse collapse in">
                 <div class="panel-body">
-                    <center>
-                        <knob knob-data="core.knobData" knob-options="knobOptions"></knob>
-                    </center>
-                    <p>Total Cores: {{status.CoreStatus.TotalCores}}</p>
-                    <p>Used Cores: {{status.CoreStatus.TotalCores - status.CoreStatus.FreeCores}}</p>
-                </div>
-            </div>
-        </div>
-
-        <div class="col-lg-3 col-md-6">
-            <div class="panel panel-default">
-                <div class="panel-heading">
-                    <h3 class="panel-title">CPU Utilization</h3>
-                </div>
-                <div class="panel-body">
-                    <center>
-                        <knob knob-data="cpu.knobData" knob-options="knobOptions"></knob>
-                    </center>
-                    <p>Total Utilization: {{status.CpuUtilizationStatus.TotalCpuUtilization}} %</p>
-                    <p>Used Utilization: {{status.CpuUtilizationStatus.UsedCpuUtilization}} %</p>
-                </div>
-            </div>
-        </div>
-
-        <div class="col-lg-3 col-md-6">
-            <div class="panel panel-default">
-                <div class="panel-heading">
-                    <h3 class="panel-title">Memory</h3>
-                </div>
-                <div class="panel-body">
-                    <center>
-                        <knob knob-data="memory.knobData" knob-options="knobOptions"></knob>
-                    </center>
-                    <p>TotalMemory: {{status.MemoryStatus.TotalMemory}} GB</p>
-                    <p>UsedMemory: {{status.MemoryStatus.TotalMemory - status.MemoryStatus.FreeMemory}} GB</p>
-                </div>
-            </div>
-        </div>
-
-        <div class="col-lg-3 col-md-6">
-            <div class="panel panel-default">
-                <div class="panel-heading">
-                    <h3 class="panel-title">Tasks</h3>
-                </div>
-                <div class="panel-body">
-                    <p>Total: {{tasks.WaitingTasks + tasks.CalculatingTasks}}</p>
-                    <p>Waiting: {{tasks.WaitingTasks}}</p>
-                    <p>Calculating: {{tasks.CalculatingTasks}}</p>
-                </div>
-            </div>
-        </div>
-    </div>
-
-    <div class="row">
-        <div class="col-lg-12">
-            <div class="panel panel-default">
-                <div class="panel-heading">
-                    <h3 class="panel-title">CPU Utilization Chart</h3>
-                </div>
-                <div class="panel-body">
-                    <flot dataset="cpu.series" options="chartOptions"></flot>
-                </div>
-            </div>
-        </div>
-    </div>
-
-    <div class="row">
-        <div class="col-lg-12">
-            <div class="panel panel-default">
-                <div class="panel-heading">
-                    <h3 class="panel-title">Core Chart</h3>
-                </div>
-                <div class="panel-body">
-                    <flot dataset="core.series" options="fillChartOptions"></flot>
-                </div>
-            </div>
-        </div>
-    </div>
-
-    <div class="row">
-        <div class="col-lg-12">
-            <div class="panel panel-default">
-                <div class="panel-heading">
-                    <h3 class="panel-title">Memory Chart</h3>
-                </div>
-                <div class="panel-body">
-                    <flot dataset="memory.series" options="fillChartOptions"></flot>
-                </div>
-            </div>
-        </div>
-    </div>
-
-    <div class="row">
-        <div class="col-lg-12">
-            <div class="panel panel-default">
-                <div class="panel-heading">
-                    <h3 class="panel-title">Tasks by User</h3>
-                </div>
-                <div class="panel-body">
-                    <table class="table table-hover">
+                    <table class="table table-hover" ts-wrapper>
                         <thead>
                             <tr>
-                                <th>Username</th>
-                                <th>Calculating Tasks</th>
-                                <th>Waiting Tasks</th>
+                                <th ts-criteria="Slave.Name">Slave</th>
+                                <th ts-criteria="CpuUtilization|parseFloat">CPU Utilization</th>
+                                <th ts-criteria="Cores|parseInt">Cores</th>
+                                <th ts-criteria="Memory|parseInt">Memory</th>
                             </tr>
                         </thead>
-                        <tr ng-repeat="task in status.TasksStatus">
-                            <td>{{task.User.Name}}</td>
-                            <td>{{task.CalculatingTasks}}</td>
-                            <td>{{task.WaitingTasks}}</td>
+                        <tbody>
+                            <tr ng-repeat="slave in activeCalculatingSlaves = (status.SlavesStatus
+                                | filter: {
+                                    IsAllowedToCalculate: true,
+                                    State: 'Calculating'
+                                  })" ts-repeat>
+                                <td>{{slave.Slave.Name}}</td>
+                                <td>{{slave.CpuUtilization | number: 2}} %</td>
+                                <td>{{slave.Cores - slave.FreeCores | number}} / {{slave.Cores | number}}</td>
+                                <td>{{slave.Memory - slave.FreeMemory | kbToGB}} / {{slave.Memory | kbToGB}} GB</td>
+                            </tr>
+                            <tr ng-hide="activeCalculatingSlaves.length">
+                                <td colspan="4" class="text-center">
+                                    There are no active calculating slaves available!
+                                </td>
+                            </tr>
+                        </tbody>
+                    </table>
+                </div>
+            </div>
+        </div>
+    </div>
+</div>
+
+<div class="row">
+    <div class="col-lg-12">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">
+                    <a data-toggle="collapse" data-target="#collapseActiveIdleSlaves"
+                       ng-href="#/status" class="collapsed">
+                        Active Idle Slaves
+                    </a>
+                </h3>
+            </div>
+            <div id="collapseActiveIdleSlaves"
+                 class="panel-collapse collapse">
+                <div class="panel-body">
+                    <table class="table table-hover" ts-wrapper>
+                        <thead>
+                        <tr>
+                            <th ts-criteria="Slave.Name">Slave</th>
+                            <th ts-criteria="CpuUtilization|parseFloat">CPU Utilization</th>
+                            <th ts-criteria="Cores|parseInt">Cores</th>
+                            <th ts-criteria="Memory|parseInt">Memory</th>
                         </tr>
+                        </thead>
+                        <tbody>
+                            <tr ng-repeat="slave in activeIdleSlaves = (status.SlavesStatus
+                                | filter: {
+                                    IsAllowedToCalculate: true,
+                                    State: 'Idle'
+                                  })" ts-repeat>
+                                <td>{{slave.Slave.Name}}</td>
+                                <td>{{slave.CpuUtilization | number: 2}} %</td>
+                                <td>{{slave.Cores - slave.FreeCores | number}} / {{slave.Cores | number}}</td>
+                                <td>{{slave.Memory - slave.FreeMemory | kbToGB}} / {{slave.Memory | kbToGB}} GB</td>
+                            </tr>
+                            <tr ng-hide="activeIdleSlaves.length">
+                                <td colspan="4" class="text-center">
+                                    There are no active idle slaves available!
+                                <td>
+                            </tr>
+                        </tbody>
                     </table>
                 </div>
@@ -135,23 +284,43 @@
         </div>
     </div>
-
-    <div class="row">
-        <div class="col-lg-12">
-            <div class="panel panel-default">
-                <div class="panel-heading">
-                    <h3 class="panel-title">CPU Utilization by Slave</h3>
-                </div>
+</div>
+
+<div class="row">
+    <div class="col-lg-12">
+        <div class="panel panel-default">
+            <div class="panel-heading">
+                <h3 class="panel-title">
+                    <a data-toggle="collapse" data-target="#collapseInactiveSlaves"
+                       ng-href="#/status" class="collapsed">
+                        Inactive Slaves
+                    </a>
+                </h3>
+            </div>
+            <div id="collapseInactiveSlaves"
+                 class="panel-collapse collapse">
                 <div class="panel-body">
-                    <table class="table table-hover">
+                    <table class="table table-hover" ts-wrapper>
                         <thead>
                             <tr>
-                                <th>Slave</th>
-                                <th>CPU Utilization</th>
+                                <th ts-criteria="Slave.Name">Slave</th>
+                                <th ts-criteria="CpuUtilization|parseFloat">CPU Utilization</th>
+                                <th ts-criteria="Cores|parseInt">Cores</th>
+                                <th ts-criteria="Memory|parseInt">Memory</th>
                             </tr>
                         </thead>
-                        <tr ng-repeat="slave in status.SlavesCpuStatus">
-                            <td>{{slave.Slave.Name}}</td>
-                            <td>{{slave.CpuUtilization}} %</td>
-                        </tr>
+                        <tbody>
+                            <tr ng-repeat="slave in inactiveSlaves = (status.SlavesStatus
+                                | filter: {
+                                    IsAllowedToCalculate: false
+                                  })" ts-repeat>
+                                <td>{{slave.Slave.Name}}</td>
+                                <td>{{slave.CpuUtilization | number: 2}} %</td>
+                                <td>{{slave.Cores - slave.FreeCores | number}} / {{slave.Cores | number}}</td>
+                                <td>{{slave.Memory - slave.FreeMemory | kbToGB}} / {{slave.Memory | kbToGB}} GB</td>
+                            </tr>
+                            <tr ng-hide="inactiveSlaves.length">
+                                <td colspan="4" class="text-center">No inactive slaves available!</td>
+                            </tr>
+                        </tbody>
                     </table>
                 </div>
@@ -160,2 +329,9 @@
     </div>
 </div>
+</div>
+
+<script>
+    $(document).ready(function () {
+        $('[data-toggle="tooltip"]').tooltip();
+    });
+</script>
Index: stable/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/statusCtrl.js
===================================================================
--- trunk/sources/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/statusCtrl.js	(revision 12428)
+++ stable/HeuristicLab.Services.WebApp.Status/3.3/WebApp/status/statusCtrl.js	(revision 12563)
@@ -53,4 +53,7 @@
                     mode: "time",
                     twelveHourClock: false
+                },
+                yaxis: {
+                    min: 0
                 }
             };
@@ -85,4 +88,6 @@
                 // update status data
                 dataService.getStatus({}, function (status) {
+                    var oneDayInMs = 24 * 60 * 60 * 1000;
+                    var today = new Date().getTime() - oneDayInMs;
                     // raw status data
                     $scope.status = status;
@@ -96,33 +101,39 @@
                     }
                     // knobs
-                    $scope.cpu.knobData = Math.round(status.CpuUtilizationStatus.UsedCpuUtilization);
-                    var usedCores = status.CoreStatus.TotalCores - status.CoreStatus.FreeCores;
-                    $scope.core.knobData = Math.round(usedCores / status.CoreStatus.TotalCores * 100);
-                    var usedMemory = status.MemoryStatus.TotalMemory - status.MemoryStatus.FreeMemory;
-                    $scope.memory.knobData = Math.round(usedMemory / status.MemoryStatus.TotalMemory * 100);
+                    $scope.cpu.knobData = Math.round(status.CpuUtilizationStatus.ActiveCpuUtilization);
+                    $scope.core.knobData = Math.round(status.CoreStatus.CalculatingCores / status.CoreStatus.ActiveCores * 100);
+                    $scope.memory.knobData = Math.round(status.MemoryStatus.UsedMemory / status.MemoryStatus.ActiveMemory * 100);
                     // chart series
                     var cpuSeries = $scope.cpu.series[0].data.splice(0);
-                    if (cpuSeries.length > 2) {
-                        cpuSeries.splice(0, 1);
+                    var coreSeries = [$scope.core.series[0].data, $scope.core.series[1].data];
+                    var memorySeries = [$scope.memory.series[0].data, $scope.memory.series[1].data];
+                    if ($scope.status.Timestamp < today) {
+                        if (cpuSeries.length > 2) {
+                            cpuSeries.splice(0, 1);
+                        }
+                        if (coreSeries[0].length > 2) {
+                            coreSeries[0].splice(0, 1);
+                        }
+                        if (coreSeries[1].length > 2) {
+                            coreSeries[1].splice(0, 1);
+                        }
+                        if (memorySeries[0].length > 2) {
+                            memorySeries[0].splice(0, 1);
+                        }
+                        if (memorySeries[1].length > 2) {
+                            memorySeries[1].splice(0, 1);
+                        }
                     }
-                    var coreSeries = [$scope.core.series[0].data, $scope.core.series[1].data];
-                    if (coreSeries[0].length > 2) {
-                        coreSeries[0].splice(0, 1);
-                    }
-                    if (coreSeries[1].length > 2) {
-                        coreSeries[1].splice(0, 1);
-                    }
-                    var memorySeries = [$scope.memory.series[0].data, $scope.memory.series[1].data];
-                    if (memorySeries[0].length > 2) {
-                        memorySeries[0].splice(0, 1);
-                    }
-                    if (memorySeries[1].length > 2) {
-                        memorySeries[1].splice(0, 1);
-                    }
-                    cpuSeries.push([$scope.status.Timestamp, $scope.cpu.knobData]);
+                    
+                    cpuSeries.push([$scope.status.Timestamp, Math.round(status.CpuUtilizationStatus.TotalCpuUtilization)]);
+                    // charts are currently filled with old total/used data
+                    // start temporary
+                    var usedCores = status.CoreStatus.TotalCores - status.CoreStatus.FreeCores;
+                    var usedMemory = status.MemoryStatus.TotalMemory - status.MemoryStatus.FreeMemory;
+                    // end temporary
                     coreSeries[0].push([$scope.status.Timestamp, status.CoreStatus.TotalCores]);
                     coreSeries[1].push([$scope.status.Timestamp, usedCores]);
-                    memorySeries[0].push([$scope.status.Timestamp, status.MemoryStatus.TotalMemory]);
-                    memorySeries[1].push([$scope.status.Timestamp, usedMemory]);
+                    memorySeries[0].push([$scope.status.Timestamp, Math.round(status.MemoryStatus.TotalMemory / 1024)]);
+                    memorySeries[1].push([$scope.status.Timestamp, Math.round(usedMemory / 1024)]);
                     $scope.cpu.series = [{ data: cpuSeries, label: "&nbsp;CPU Utilization", color: "#f7921d" }];
                     $scope.core.series = [
@@ -145,16 +156,14 @@
                     var noOfStatus = status.length;
                     var cpuSeries = [];
-                    var coreSeries = [[],[]];
-                    var memorySeries = [[],[]];
+                    var coreSeries = [[], []];
+                    var memorySeries = [[], []];
                     for (var i = 0; i < noOfStatus; ++i) {
                         var curStatus = status[i];
-                        var cpuData = Math.round(curStatus.CpuUtilizationStatus.UsedCpuUtilization);
-                        var usedCores = curStatus.CoreStatus.TotalCores - curStatus.CoreStatus.FreeCores;
-                        var usedMemory = curStatus.MemoryStatus.TotalMemory - curStatus.MemoryStatus.FreeMemory;
+                        var cpuData = Math.round(curStatus.CpuUtilizationStatus.ActiveCpuUtilization);
                         cpuSeries.push([curStatus.Timestamp, cpuData]);
-                        coreSeries[0].push([curStatus.Timestamp, curStatus.CoreStatus.TotalCores]);
-                        coreSeries[1].push([curStatus.Timestamp, usedCores]);
-                        memorySeries[0].push([curStatus.Timestamp, curStatus.MemoryStatus.TotalMemory]);
-                        memorySeries[1].push([curStatus.Timestamp, usedMemory]);
+                        coreSeries[0].push([curStatus.Timestamp, curStatus.CoreStatus.ActiveCores]);
+                        coreSeries[1].push([curStatus.Timestamp, curStatus.CoreStatus.CalculatingCores]);
+                        memorySeries[0].push([curStatus.Timestamp, Math.round(curStatus.MemoryStatus.ActiveMemory / 1024)]);
+                        memorySeries[1].push([curStatus.Timestamp, Math.round(curStatus.MemoryStatus.UsedMemory / 1024)]);
                     }
                     $scope.cpu.series = [{ data: cpuSeries, label: "&nbsp;CPU Utilization", color: "#f7921d" }];