Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/IInteractionInitializer.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/IInteractionInitializer.cs	(revision 8172)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/IInteractionInitializer.cs	(revision 12566)
@@ -1,6 +1,23 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
 using HeuristicLab.Core;
 using HeuristicLab.Data;
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/IncreasingBlockSizeInteractionsInitializer.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/IncreasingBlockSizeInteractionsInitializer.cs	(revision 8172)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/IncreasingBlockSizeInteractionsInitializer.cs	(revision 12566)
@@ -1,13 +1,30 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Common;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Encodings.BinaryVectorEncoding;
-using HeuristicLab.Parameters;
-using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.NK {
@@ -15,22 +32,22 @@
   [Item("IncreasingBlockSizeInteractionsInitializer", "Randomly assignes interactions across all bits but makes sure that different numbers of ineractions are applied to different bits.")]
   [StorableClass]
-  public class IncreasingBlockSizeInteractionsInitializer : ParameterizedNamedItem, IInteractionInitializer {    
-    
+  public class IncreasingBlockSizeInteractionsInitializer : ParameterizedNamedItem, IInteractionInitializer {
+
     [StorableConstructor]
     protected IncreasingBlockSizeInteractionsInitializer(bool serializing) : base(serializing) { }
     protected IncreasingBlockSizeInteractionsInitializer(IncreasingBlockSizeInteractionsInitializer original, Cloner cloner) : base(original, cloner) { }
-    public IncreasingBlockSizeInteractionsInitializer() {      
+    public IncreasingBlockSizeInteractionsInitializer() {
     }
-    
+
 
     public override IDeepCloneable Clone(Cloner cloner) {
       return new IncreasingBlockSizeInteractionsInitializer(this, cloner);
-    }    
+    }
 
     #region IInteractionInitializer Members
     public BoolMatrix InitializeInterations(int length, int nComponents, int nInteractions, IRandom random) {
       Dictionary<int, int> bitInteractionCounts = new Dictionary<int, int>();
-      for (int i = 0; i<length; i++) {
-        int count = nInteractions*2*i/length;
+      for (int i = 0; i < length; i++) {
+        int count = nInteractions * 2 * i / length;
         if (count > 0)
           bitInteractionCounts[i] = count;
@@ -39,5 +56,5 @@
       while (bitInteractionCounts.Count > 0) {
         BinaryVector component = new BinaryVector(length);
-        for (int i = 0; i<nInteractions; i++) {          
+        for (int i = 0; i < nInteractions; i++) {
           while (bitInteractionCounts.Count > 0) {
             int bit = bitInteractionCounts.ElementAt(random.Next(bitInteractionCounts.Count)).Key;
@@ -48,13 +65,13 @@
               break;
             }
-          }          
+          }
         }
         components.Add(component);
-      }      
+      }
       BoolMatrix m = new BoolMatrix(length, components.Count);
-      foreach (var c in components.Select((v, j) => new {v, j})) {
-        for (int i = 0; i<c.v.Length; i++) {
+      foreach (var c in components.Select((v, j) => new { v, j })) {
+        for (int i = 0; i < c.v.Length; i++) {
           m[i, c.j] = c.v[i];
-        }    
+        }
       }
       return m;
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/LimitedRandomInteractionsInitializer.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/LimitedRandomInteractionsInitializer.cs	(revision 8172)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/LimitedRandomInteractionsInitializer.cs	(revision 12566)
@@ -1,13 +1,30 @@
-﻿using System;
-using System.Collections.Generic;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Linq;
-using System.Text;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Common;
+using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Encodings.BinaryVectorEncoding;
-using HeuristicLab.Parameters;
-using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.NK {
@@ -34,17 +51,17 @@
     public ValueParameter<DoubleValue> MaximumDistanceRatioParameter {
       get { return (ValueParameter<DoubleValue>)Parameters["MaximumDistanceRatio"]; }
-    }    
+    }
 
     private int MaximumDistance(int length, int nInteractions) {
       int maxBitDist = MaximumDistanceParameter.Value.Value;
       double maxDistRatio = MaximumDistanceRatioParameter.Value.Value;
-      maxBitDist =  Math.Min(
+      maxBitDist = Math.Min(
         maxBitDist == 0 ? length : maxBitDist,
-        maxDistRatio == 0 ? length : (int)Math.Round(maxDistRatio*length));      
+        maxDistRatio == 0 ? length : (int)Math.Round(maxDistRatio * length));
       if (maxBitDist * 2 < nInteractions)
         maxBitDist = (int)Math.Ceiling(0.5 * nInteractions);
       return maxBitDist;
-    }    
-        
+    }
+
     [StorableConstructor]
     protected LimitedRandomInteractionsInitializer(bool serializing) : base(serializing) { }
@@ -54,8 +71,8 @@
       Parameters.Add(new ValueParameter<DoubleValue>("MaximumDistanceRatio", "Maximum distance of interactions as ratio of the total length or 0 for unlimited"));
     }
-    
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new LimitedRandomInteractionsInitializer(this, cloner);
-    }    
+    }
 
     #region IInteractionInitializer Members
@@ -63,12 +80,12 @@
       BoolMatrix m = new BoolMatrix(length, nComponents);
       int maxBitDistance = MaximumDistance(length, nInteractions);
-      var minBounds = new Bounds(0, length-nInteractions);
-      var maxBounds = new Bounds(nInteractions, length-1);
-      for (int c = 0; c<m.Columns; c++) {
-        int min = minBounds.bounded(c-maxBitDistance);
-        int max = maxBounds.bounded(c+maxBitDistance);
-        var indices = Enumerable.Range(min, max-min).ToList();
+      var minBounds = new Bounds(0, length - nInteractions);
+      var maxBounds = new Bounds(nInteractions, length - 1);
+      for (int c = 0; c < m.Columns; c++) {
+        int min = minBounds.bounded(c - maxBitDistance);
+        int max = maxBounds.bounded(c + maxBitDistance);
+        var indices = Enumerable.Range(min, max - min).ToList();
         indices.Remove(c);
-        m[c, c] = true;        
+        m[c, c] = true;
         while (indices.Count > nInteractions) {
           indices.RemoveAt(random.Next(indices.Count));
@@ -78,5 +95,5 @@
         }
       }
-      return m;      
+      return m;
     }
     #endregion
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/RandomInteractionsInitializer.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/RandomInteractionsInitializer.cs	(revision 8172)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/RandomInteractionsInitializer.cs	(revision 12566)
@@ -1,9 +1,27 @@
-﻿using System;
-using System.Collections.Generic;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
 using System.Linq;
-using System.Text;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -32,5 +50,5 @@
     public BoolMatrix InitializeInterations(int length, int nComponents, int nInteractions, IRandom random) {
       BoolMatrix m = new BoolMatrix(length, nComponents);
-      for (int c = 0; c<m.Columns; c++) {
+      for (int c = 0; c < m.Columns; c++) {
         var indices = Enumerable.Range(0, length).ToList();
         if (indices.Count > c) {
@@ -45,5 +63,5 @@
         }
       }
-      return m;      
+      return m;
     }
     #endregion
Index: branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/SortedRandomInteractionsInitializer.cs
===================================================================
--- branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/SortedRandomInteractionsInitializer.cs	(revision 8172)
+++ branches/FitnessLandscapeAnalysis/HeuristicLab.Problems.NK/InteractionInitializers/SortedRandomInteractionsInitializer.cs	(revision 12566)
@@ -1,3 +1,24 @@
-﻿using System.Linq;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;