Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Alps.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Alps.cs	(revision 12569)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Alps.cs	(revision 12570)
@@ -172,4 +172,8 @@
     protected Alps(bool deserializing)
       : base(deserializing) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      Initialize();
+    }
     protected Alps(Alps original, Cloner cloner)
       : base(original, cloner) {
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs	(revision 12569)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs	(revision 12570)
@@ -116,4 +116,8 @@
     private AlpsGeneticAlgorithm(bool deserializing)
       : base(deserializing) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      Initialize();
+    }
     private AlpsGeneticAlgorithm(AlpsGeneticAlgorithm original, Cloner cloner)
       : base(original, cloner) {
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeCalculator.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeCalculator.cs	(revision 12569)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/Analyzers/OldestAverageYoungestAgeCalculator.cs	(revision 12570)
@@ -30,5 +30,5 @@
   [Item("OldestAverageYoungestAgeCalculator", "An operator which calculates the oldest, average and youngest age of solutions in the scope tree.")]
   [StorableClass]
-  public class OldestAverageYoungestAgeCalculator : SingleSuccessorOperator {
+  public sealed class OldestAverageYoungestAgeCalculator : SingleSuccessorOperator {
     public IScopeTreeLookupParameter<IntValue> AgeParameter {
       get { return (IScopeTreeLookupParameter<IntValue>)Parameters["Age"]; }
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerSorter.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerSorter.cs	(revision 12569)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerSorter.cs	(revision 12570)
@@ -30,5 +30,5 @@
   [Item("LayerSorter", "")]
   [StorableClass]
-  public class LayerSorter : SingleSuccessorOperator {
+  public sealed class LayerSorter : SingleSuccessorOperator {
     private IScopeTreeLookupParameter<IntValue> LayerParameter {
       get { return (IScopeTreeLookupParameter<IntValue>)Parameters["Layer"]; }
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerUniformSubScopesProcessor.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerUniformSubScopesProcessor.cs	(revision 12569)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerUniformSubScopesProcessor.cs	(revision 12570)
@@ -34,5 +34,5 @@
   [Item("LayerUniformSubScopesProcessor", "")]
   [StorableClass]
-  public class LayerUniformSubScopesProcessor : SingleSuccessorOperator {
+  public sealed class LayerUniformSubScopesProcessor : SingleSuccessorOperator {
     private OperatorParameter OperatorParameter {
       get { return (OperatorParameter)Parameters["Operator"]; }
@@ -94,5 +94,5 @@
   [Item("LayerIntermediateParameter", "")]
   [StorableClass]
-  public class LayerIntermediateParameter : ParameterizedNamedItem, IEnumerable<IParameter> {
+  public sealed class LayerIntermediateParameter : ParameterizedNamedItem, IEnumerable<IParameter> {
     [StorableConstructor]
     private LayerIntermediateParameter(bool deserializing) : base(deserializing) { }
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerUpdator.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerUpdator.cs	(revision 12569)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerUpdator.cs	(revision 12570)
@@ -34,5 +34,5 @@
   [Item("LayerUpdator", "Operator which manages the reseeding and creation of layers.")]
   [StorableClass]
-  public class LayerUpdator : AlgorithmOperator {
+  public sealed class LayerUpdator : AlgorithmOperator {
 
     public SolutionsCreator SolutionsCreator {